//+------------------------------------------------------------------+
//|                                 BasedOnIndicatorExpertSignal.mqh |
//|                                                    2011, etrader |
//|                                             http://efftrading.ru |
//+------------------------------------------------------------------+
#property copyright "2011, etrader"
#property link      "http://efftrading.ru"
#include <Expert\ExpertSignal.mqh>
//+------------------------------------------------------------------+
//|   CBasedOnIndicatorExpertSignal                             |
//| :               |
//|                                       |
//+------------------------------------------------------------------+
class CBasedOnIndicatorExpertSignal: public CExpertSignal{
  protected:
    CiCustom m_indicator;    //   
    MqlParam m_parameters[]; //  ,    
  public:
    void CBasedOnIndicatorExpertSignal(){ 
//---    
      m_used_series=USE_SERIES_OPEN+USE_SERIES_HIGH+USE_SERIES_LOW+USE_SERIES_CLOSE+USE_SERIES_TIME; 
    }
    virtual bool      InitIndicators(CIndicators* indicators);        //  
    virtual bool      InitCustomIndicator(CIndicators* indicators);   // ,   
    virtual void      FillParameters(){};                             //     m_parameters
};

//+------------------------------------------------------------------+
//|                                          |
//| INPUT:  indicators -              |
//| OUTPUT: true-, false                                 |
//| REMARK:                                                       |
//+------------------------------------------------------------------+
bool CBasedOnIndicatorExpertSignal::InitIndicators(CIndicators* indicators){
//---  
   if(indicators==NULL)                           return(false);
//---      
   if(!CExpertSignal::InitIndicators(indicators)) return(false);
//---     
   if(!InitCustomIndicator(indicators))           return(false);
//--- ok
   return(true);
}


//+------------------------------------------------------------------+
//|                          |
//| INPUT: indicators -               |
//| OUTPUT: true-, false -                               |
//| REMARK:                                                       |
//+------------------------------------------------------------------+
bool CBasedOnIndicatorExpertSignal::InitCustomIndicator(CIndicators* indicators) {
//---  
   if(indicators==NULL) return(false);
//---    
   if(!indicators.Add(GetPointer(m_indicator))){
      printf(__FUNCTION__+":   ");
      return(false);
   }
//---    
   FillParameters();
//---  
   if(!m_indicator.Create(m_symbol.Name(),m_period,IND_CUSTOM, ArraySize(m_parameters), m_parameters  )){
      printf(__FUNCTION__+":   ");
      return(false);
   }
//--- ok
   return(true);
}

//+------------------------------------------------------------------+
